<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Home - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2>
    
</nav>

<div id="main">
    

    



    


    <section class="package">
        <h3> </h3>		
    </section>









    



    <section class="readme usertext">
        <article><h1>esp32galileo</h1>
<p>ESP32 firmware providing a REST API for controlling the galileo science outreach setup</p>
<div style='float:right;margin-left:20px'><a target=_blank' href='https://line.gitlabpages.inria.fr/aide-group/aide/index.html'><img alt='AIDE API docs' src='https://line.gitlabpages.inria.fr/aide-group/aide/img/icons8-api-aide.png'/></a></div>
<h2>A ESP32 micro-controller to drive the galileo board experiment</h2>
<p>This software package provides the <a href="https://en.wikipedia.org/wiki/ESP32">ESP32</a> micro-controller firmware to drive the galileo board experiment.</p>
<p><img src="https://line.gitlabpages.inria.fr/aide-group/esp32galileo/view.png" alt="Setup view" title="Setup view"></p>
<h3>Web interface</h3>
<p><img src="https://line.gitlabpages.inria.fr/aide-group/esp32galileo/setup_galileo_page.png" alt="HTML web interface" title="HTML web interface"></p>
<h3>Doing the experiment</h3>
<ul>
<li>Install the four optical sensors either
<ul>
<li>at equal distances in order to see the acceleration, or</li>
<li>at increasing distances to obtain equal time intervals.</li>
</ul>
</li>
<li>Stick the metal ball onto the electromagnet.</li>
<li>Press the button on the setup of the HTML interface <code>Run</code> button and observe the ball fall.</li>
<li>Press the HTML interface <code>Get</code> button at the motion end to get the detected times, velocities and accelerations.</li>
</ul>
<p>Tutorial video: <a href="https://youtu.be/ew7ONP2M09M">https://youtu.be/ew7ONP2M09M</a></p>
<h3>Remarks:</h3>
<ul>
<li>The <code>Start</code> and <code>Stop</code> command are only used for debug.</li>
<li>The <code>Get</code> output is of the form</li>
</ul>
<pre class="prettyprint source"><code>{
  &quot;route&quot;: 
  &quot;galileo&quot;, 
  &quot;time&quot;: 0.000,        // Current time in second when the `Get` button is pressed.
  &quot;start_time&quot;: 0.000,  // Experiment time in second, when the `Run` button is pressed.
  &quot;detected_times&quot;: [0.000, 0.000, 0.000, 0.000], // Relative times of optical sensor detection, after start_time.
  &quot;detected_velocities&quot;: [0.000, 0.000, 0.000],   // Times differences of optical sensor detection.
  &quot;detected_accelerations&quot;: [0.00000, 0.00000]    // Times differences of times differences.
}
</code></pre>
<ul>
<li>Result prediction:
<ul>
<li>The ball trajectory writes <code>x(t) = k t^2</code>, since the initial velocity is zero, and considering the electromagnet position as origin
<ul>
<li>with <code>k = 1/2 g sin(alpha) ~ 1.5</code> when <code>g = 9.81 m/s^2</code> is the gravity constant <code>alpha ~ 15 deg</code> is the board inclination.</li>
</ul>
</li>
<li>In case of equal distances we expect the detected times and velocities to decrease, and accelerations to be similar.</li>
<li>In case of increasing distance we expect the detected times differences to be similar.</li>
</ul>
</li>
</ul>
<h2>References</h2>
<ul>
<li>The <a href="https://pixees.fr/plan-incline-de-galilee/">science outreach activity and mechanical hardware description</a> (in French)</li>
<li>The <a href="https://gitlab.inria.fr/line/aide-group/esp32galileo/-/blob/master/src/hardware.md">electronic hardware description</a></li>
<li>The <a href="https://gitlab.inria.fr/line/aide-group/esp32galileo/-/blob/master/src/usage_galileo.md">webservice usage description</a></li>
</ul>
<p><a name='what'></a></p>
<h2>Package repository</h2>
<ul>
<li>Package files: <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/esp32galileo'>https://gitlab.inria.fr/line/aide-group/esp32galileo</a></li>
<li>Package documentation: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/esp32galileo'>https://line.gitlabpages.inria.fr/aide-group/esp32galileo</a></li>
<li>Source files: <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/esp32galileo/-/tree/master/src'>https://gitlab.inria.fr/line/aide-group/esp32galileo/-/tree/master/src</a></li>
<li>Version <code>1.1.1</code></li>
<li>License <code>CECILL-C</code></li>
</ul>
<h2>Installation</h2>
<h3>User simple installation</h3>
<ul>
<li><code>npm install git+https://gitlab.inria.fr/line/aide-group/esp32galileo.git</code></li>
</ul>
<h3>Co-developper installation</h3>
<ul>
<li>See the <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild/install.html#.install_as_developer'>related documentation</a></li>
</ul>
<p>Please refer to the <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild/install.html'>installation guide</a> for installation.</p>
<p><a name='how'></a></p>
<h2>Usage</h2>
<ul>
<li>Refer to <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/esp32galileo/-/blob/master/src/usage_galileo.md'>usage_galileo</a>, for the Galileo mechanism web service usage.</li>
</ul>
<h3>npm script usage</h3>
<pre class="prettyprint source"><code>npm install --quiet : installs all package dependencies and sources.
npm run build: builds the different compiled, documentation and test files.
npm test     : runs functional and non-regression tests.
npm run clean: cleans installation files.
</code></pre>
<p><a name='dep'></a></p>
<h2>Dependencies</h2>
<ul>
<li><tt>esp32gpiocontrol: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/esp32gpiocontrol'>ESP32 firmware providing a REST API for controlling the GPIO interface and higher functions</a></tt></li>
</ul>
<h2>devDependencies</h2>
<ul>
<li><tt>aidebuild: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild'>Builds multi-language compilation packages and related documentation.</a></tt></li>
</ul>
<p><a name='who'></a></p>
<h2>Authors</h2>
<ul>
<li>Éric Pascual  <big><a target='_blank' href='mailto:eric.g.pascual@gmail.com'>🖂</a></big>  <big><a target='_blank' href='https://twitter.com/ericpobot'>🗏</a></big></li>
<li>Martine Olivi  <big><a target='_blank' href='mailto:martine.olivi@inria.fr'>🖂</a></big>  <big><a target='_blank' href='https://www-sop.inria.fr/members/Martine.Olivi/'>🗏</a></big></li>
<li>Sabrina Barnabé  <big><a target='_blank' href='mailto:snjl-contact@gmail.com'>🖂</a></big>  <big><a target='_blank' href='https://snjl.fr'>🗏</a></big></li>
<li>Thierry Viéville  <big><a target='_blank' href='mailto:thierry.vieville@inria.fr'>🖂</a></big></li>
</ul></article>
    </section>






    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>